bd4442a5248d841fd0b804eaab59ca5c8adab1a8
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies:
19 # lsdvd dvdauthor gddrescue dvdbackup makexml tovid mencoder vlc mplayer genisoimage
20 #
21 # Optional Dependencies:
22 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
23 #
24
25 ###############################################
26 # Local Machine Settings - EDIT THIS SECTION
27
28 # Specify the device path to the DVD drive
29 dev=/dev/dvd2
30
31 # Specify the path to the log directory 
32 logdir=/var/log/ripdvd
33
34 # Specify the path to the tmp rip directory
35 tmpdir=/myth/video/DVDs/.ripdvd
36
37 # Specify the email address to send job notifications to
38 mailto=ajp@pippins.net
39
40 # Setup the path to the tools needed by this ripper
41 PATH=/etc/mythtv/bin:/usr/local/bin:/usr/sbin:/sbin:/usr/bin:.:$PATH
42
43 # Use mplayer dumpstream to create the main VOB file
44 # If set to 0, cat and other utils will be used to make it instead.
45 # Using mplayer dumpstream is by far the best way to create the main VOB file
46 # The only thing this doesn't work for are DVDs with the 99 title copy protection.
47 # The script will autodetect these types of disks, and change this to 0 if necessary.
48 # If this is set to 0, other methods will be employed to get the DVD VOB dump.
49 use_mplayer_dumpstream=1
50
51 # 2-channel AVI encoding audio bit rate
52 audio_bitrate=224
53
54 # If set to 1, this script will call another script to fill in the mythvideo metadata
55 # If you don't use mythtv, set this option to 0. If you use mythtv, and have downloaded
56 # the fill_mythvideo_metadata.pl script shown above, you can leave this option set to 1.
57 fill_mythvideo_metadata=1
58
59 # If the 99 titleset copy protection scheme is detected, trust the autodetection or abort.
60 # The autodetection may work, but it probably won't in this case. Set to 0 by default. 
61 # Override to 1 if you want the script to wing it, and hope it picks the right feature title.
62 # Otherwise, you will need to rerun the script providing the feature title with the -t option.
63 trust_feature_title_autodetect_when_uncertain=0
64
65 ###############################################
66 # Command line processing
67 typeset dvdname=""
68 typeset debug=""
69 typeset dest=""
70 typeset isofile=""
71 typeset vobfile=""
72 typeset dvdpath=""
73 typeset -i keep_intermediate_files=0
74 typeset -i make_final_dest_vob=0
75 typeset -i make_final_dest_iso=0
76 typeset -i make_final_dest_folder=0
77 typeset -i make_final_dest_avi=0
78 typeset -i errors=0
79 typeset -i show_usage=0
80 typeset -i mirror_mode=0
81 typeset -i target_bitrate=0
82 typeset -i target_size=0
83 typeset -i audio_2ch=0
84 typeset -i invalid_feature_title=0
85 typeset -i feature_title_override=0
86 typeset -i mplayer_dumpstream_incompatibility=0
87
88 while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
89 do
90     case $opt in
91         (n)     dvdname=$OPTARG;;
92         (d)     dest=$OPTARG;;
93         (b)     target_bitrate=$OPTARG;;
94         (s)     target_size=$OPTARG;;
95         (2)     audio_2ch=1;;
96         (v)     make_final_dest_vob=1;;
97         (i)     make_final_dest_iso=1;;
98         (f)     make_final_dest_folder=1;; 
99         (x)     make_final_dest_avi=1;;
100         (m)     mirror_mode=1;;
101         (k)     keep_intermediate_files=1;;
102         (t)     feature_title_override=$OPTARG;;
103         (w)     set -$opt;;
104         (h)     show_usage=1;;
105         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
106         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
107     esac
108 done
109
110 shift $((OPTIND-1))
111
112 function usage() {
113     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
114     echo >&2 "Revision $REV"
115     echo >&2 "Options:"
116     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
117     echo >&2 "   -n <dvdname>  Specify what the name of the DVD is to process from $tmpdir"
118     echo >&2 "                 If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
119     echo >&2 "                 If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
120     echo >&2 "                 This is optional. If not specified, the dvd will be pulled from $dev"
121     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
122     echo >&2 "                 The default operation is non-mirror mode where only the main"
123     echo >&2 "                 feature title will be ripped."
124     echo >&2 "   -v            Make the final image a DVD VOB file"
125     echo >&2 "   -i            Make the final image a DVD ISO file"
126     echo >&2 "   -f            Make the final image a DVD folder"
127     echo >&2 "   -x            Make the final image an AVI (XVID) file"
128     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
129     echo >&2 "   -s <size>     Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
130     echo >&2 "   -b <bitrate>  Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"    
131     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
132     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
133     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
134     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
135     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
136     echo >&2 "   -w            Set the sh Execute/Verbose flag"
137     echo >&2 ""
138     exit 2
139 }
140
141 if (($errors)) || (($show_usage))
142 then
143   usage
144 fi
145
146 # Sanity Check - Command Line Options 
147 if [ "$dest" == "" ]; then
148   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
149   usage
150 fi
151
152 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
153   echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
154   usage
155 fi
156
157 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
158   echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
159   usage
160 fi
161
162 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
163    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
164   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
165   usage
166 fi
167
168 if [ $mirror_mode -eq 1 ]; then
169   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
170      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
171     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
172     usage
173   fi
174 fi
175
176 # Sanity Check - Key executables
177 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
178 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
179 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
180 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
181 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
182 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
183 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
184 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
185
186 ###############################################
187
188 typeset -i ripdvd
189 if [ -z "$dvdname" ]; then
190   # make sure the DVD device is accessible
191   volname $dev > /dev/null 2>&1
192   if [ $? != 0 ]; then
193     echo "-E- Can't access the DVD device $dev"
194     exit 1
195   fi
196   # now capture the volume name from the device
197   dvdname=`volname $dev | awk '{ print $1 }'`
198   ripdvd=1
199 else 
200   # check to see if dvdname is a full path to a real directory
201   # if it is, set dvdname and dvdpath appropriately
202   if [ -d "$dvdname" ]; then
203     dvdpath="$dvdname"
204     dvdname=`basename "$dvdname"`
205     if [ -z "$dvdname" ]; then
206      echo "-E- Unable to extract dvdname from path: $dvdpath"
207      exit 1
208     fi
209     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
210       echo "-E- You must supply a full path to a valid DVD folder with this option"
211       exit 1
212     fi
213   fi
214   # check to see if dvdname is a full path to an MPG2 (VOB) file
215   # if it is, set dvdname and vobfile appropriately
216   if [ -f "$dvdname" ]; then
217     vobfile="$dvdname"
218     dvdname=`basename "$dvdname"`
219     file "$vobfile" | grep -q "MPEG"
220     if [ $? == 0 ]; then
221       # It is a valid MPEG2 file, now strip the extension off our dvdname
222       dvdname=${dvdname%.[^.]*}
223     else 
224       echo "-E- Unsupported file type: $vobfile"
225       exit 1
226     fi
227   fi
228   ripdvd=0
229 fi
230
231 # Make sure we have a non-empty dvdname
232 if [ -z "$dvdname" ]; then
233   echo "-E- unable to determine dvdname"
234   exit 1
235 fi
236
237 # make sure our vobfile value is set
238 if [ -z "$vobfile" ]; then
239   vobfile="$dest/$dvdname.VOB"
240 fi
241
242 # make a "safe" dvdname (remove special characters)
243 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
244
245 # set up some variables to hold various logfiles
246 logfile="$logdir/$dvdname.log"
247 passlogfile="$tmpdir/$safedvdname.log"
248 ddrescuelog=`tempfile`
249 dvdauthorlog=`tempfile`
250 encodelog=`tempfile`
251 dumplog=`tempfile`
252
253 # create the tmpdir if it doesn't already exist
254 if [ ! -d "$tmpdir" ]; then
255   mkdir -p "$tmpdir"
256   if [ $? != 0 ]; then
257     echo "-E- Unable to create the tmpdir: $tmpdir"
258     exit 1
259   fi
260 fi
261
262 # create the logdir if it doesn't already exist
263 if [ ! -d "$logdir" ]; then
264   mkdir -p "$logdir"
265   if [ $? != 0 ]; then
266     echo "-E- Unable to create the logdir: $logdir"
267     exit 1
268   fi
269 fi
270
271 ###############################################
272 # cleanup functions
273 cleanup() { 
274   if [ $keep_intermediate_files -eq 0 ]; then
275     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
276     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
277     [[ -e "$encodelog" ]] && rm -f "$encodelog"
278     [[ -e "$dumplog" ]] && rm -f "$dumplog"
279   else
280     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
281     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
282     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
283     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
284   fi
285   echo ""
286 }
287
288 fatal_and_exit() {
289   if [[ -z "$1" ]]; then
290     msg="-E- control-c killed us"
291   else
292     msg=$1
293   fi
294   echo -e 2>&1 "$msg" | tee -a "$logfile"
295   if [[ -n "$mailto" ]]; then
296     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
297   fi
298   exit 1
299 }
300
301 # Call our cleanup functions on INT and EXIT signals
302 trap fatal_and_exit INT
303 trap cleanup EXIT
304
305 ###############################################
306 # processing functions
307 function make_dvd_iso_image {
308
309   isofile="$1"
310
311   # check to see if we have a dvdpath to rip from instead of $dev
312   if [ -z "$dvdpath" ]; then
313     # load the CSS codes in the DVD drive 
314     lsdvd $dev >> "$logfile"
315     if [ $? != 0 ]; then
316       fatal_and_exit "-E- lsdvd $dev failed" 
317     fi
318
319     # read the DVD, ignoring/skipping CRC errors
320     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
321     if [ $? != 0 ]; then
322       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
323     fi
324     cat "$ddrescuelog" >> "$logfile"
325   else
326     # rip from a path instead
327     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
328   fi
329 }
330
331 function make_dvd_iso_image_from_folder {
332   
333   src="$1"
334   dst="$2"
335   handle_error=$3
336   
337   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
338
339   # make an iso image out of our directory
340   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
341   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
342
343   # make sure we were able to create the iso image from the folder given to us
344   if [ ! -s "$tmpdir/$dvdname.iso" ] && [ $handle_error -eq 1 ]; then
345     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
346     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
347     # get the feature title from the DVD folder
348     get_feature_title "$dvdpath"
349     # create our main VOB file from the ISO
350     create_main_vob_with_mplayer "$dvdpath"
351   fi
352 }
353
354 function make_dvdbackup_folder_image {
355   # extract the feature title from the DVD image
356   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
357   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
358   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
359   if [ $? != 0 ]; then
360     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
361   fi
362 }
363
364 function make_dvdauthor_folder_image {
365   # create a new DVD video of the feature title
366   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
367   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
368   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
369   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
370
371   # There is a chance that dvdauthor won't like some of the VOBs.
372   # We can't tell ahead of time which ones it will choke on. 
373   # So, we need to run it over and over again until it can process
374   # all the VOBs. If it can't handle one of them, run it through
375   # mencoder to fix it and try again. These errors are typically
376   # present due to the copy protection that ddrescue removed.
377   grep -q "SCR moves" $dvdauthorlog
378   while [ $? == 0 ]; do
379     # fix bad vobs that get the "SCR moves backwards" error:
380     #  STAT: Processing VTS_01_0.VOB...
381     #  ERR:  SCR moves backwards, remultiplex input.
382     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
383     if [[ ! -f "$badvob" ]]; then
384       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
385     fi
386     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
387     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
388     mv -f $badvob.fixed $badvob
389     echo "-> Creating DVD video $dest/$dvdname"
390     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
391     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
392     grep -q "SCR moves" $dvdauthorlog
393   done
394 }
395
396 function get_feature_title {
397   source="$1"
398   # if a feature title was given on the command line, use it
399   if [ $feature_title_override -ne 0 ]; then
400     feature_title=$feature_title_override
401     return 0
402   fi
403   # otherwise, use lsdvd to figure it out
404   if [ $ripdvd -eq 1 ]; then
405     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
406   else 
407     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
408   fi
409 }
410
411 function create_main_vob_with_cat {
412   # cd to the feature title DVD folder
413   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
414   if [ $? != 0 ]; then
415     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
416   fi
417
418   # concatenate all the VOBs together into 1 giant VOB
419   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
420   cat $vobs > "$tmpdir/$dvdname.VOB"
421
422   # cd back to the dir we started from
423   popd > /dev/null 2>&1
424 }
425
426 function create_main_vob_with_mplayer {
427
428   # argument processing  
429   source="$1"
430   remove_dumplog=$2
431
432   # make sure we have a valid feature title
433   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
434     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
435   fi
436
437   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
438   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
439     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
440     msg="$msg We also detected another condition that requires us to use dumpstream. "
441     msg="$msg\n    Unable to rip this DVD in the mode you requested."
442     fatal_and_exit "$msg"
443   fi
444
445   # use mplayer to create the main VOB file
446   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
447   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
448   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
449   if [ $? != 0 ]; then
450     cat $dumplog | grep -v "^A:" >> "$logfile"
451     fatal_and_exit "-E- Mplayer Failed"
452   fi
453   cat $dumplog | grep -v "^A:" >> "$logfile"
454   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
455 }
456
457 function get_audio_id_from_iso {
458   # Adjust our audio ID to find the english audio stream
459   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
460   aidcheck=`tempfile`
461   aid=128
462   mplayer -v -endpos 0 -dvd-device "$isofile" dvd://$feature_title > $aidcheck 2>&1
463   grep -q "aid: $aid" $aidcheck
464   while [ $? == 1 ] && [ $aid -lt 159 ]; do
465     (( aid = aid + 1 ))
466     grep -q "aid: $aid" $aidcheck
467   done
468   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
469   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
470   # mencoder default DVD audio track language selection (english)
471   lang_opts="-aid $aid -alang en"
472 }
473
474 function get_crop_from_iso { 
475   FRAMES=10000
476   echo "-> Detecting black frame border crop value from ISO file"
477   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
478   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
479   [[ -e "md5sums" ]] && rm -f "md5sums"
480   CROP=`cat $dumplog | grep CROP | tail -1`
481   echo "   Found crop value of $CROP" >> "$logfile"
482   CROP=${CROP#* crop=}
483   CROP=${CROP%%\).*}
484   typeset -i CROPCHECK
485   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
486   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
487   if [ -z "$CROP" ]; then
488     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
489   fi
490   if [ $CROPCHECK -lt 0 ]; then 
491     CROP=""
492   else 
493     CROP=",crop=$CROP"
494   fi
495   echo "   Setting mencoder crop filter to: $CROP"
496 }
497
498 function get_audio_id_from_vob {
499   # Adjust our audio ID to find the english audio stream
500   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
501   aidcheck=`tempfile`
502   aid=128
503   mplayer -v -endpos 0 "$tmpdir/$dvdname.VOB" > $aidcheck 2>&1
504   grep -q "Found audio stream: $aid" $aidcheck
505   while [ $? == 1 ] && [ $aid -lt 159 ]; do
506     (( aid = aid + 1 ))
507     grep -q "Found audio stream: $aid" $aidcheck
508   done
509   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
510   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
511   # mencoder default DVD audio track language selection (english)
512   lang_opts="-aid $aid -alang en"
513 }
514
515 function check_vob_for_corrupted_start {
516   # check to see if the beginning of the DVD has a form of copy protection
517   # where they have deliberately broken the first X number of frames of the DVD.
518   # If we don't skip these, our resulting VOB file will not play.
519   badvobcheck=`tempfile`
520   endpos=360
521   skip=0
522   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
523   if [ $? != 0 ]; then
524     fatal_and_exit "-E- Mencoder Failed"
525   fi
526   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
527   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
528     (( skip = skip + 5 ))
529     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
530     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
531     if [ $? != 0 ]; then
532       fatal_and_exit "-E- Mencoder Failed"
533     fi
534     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
535   done
536   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
537
538   # cat the giant VOB into mencoder to create a playable VOB file
539   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
540   if [ $? != 0 ]; then
541     fatal_and_exit "-E- Mencoder Failed"
542   fi
543 }
544
545 function check_vob_for_completeness {
546   # check to make sure we got out a complete VOB.
547   # there is another kind of copy protection where the VOB's may
548   # have "MPG EOF" frames in the middle of the stream. 
549   # this causes mencoder to not process the entire VOB, and exit without any errors.
550   # detect this by seeing how much smaller the dst vob is from the src vob.
551   MAX_FILESIZE_DELTA_PERCENT=70
552   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
553   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
554   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
555   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
556     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
557     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
558     create_main_vob_with_mplayer "$isofile"
559     [[ -e "$dumplog" ]] && rm -f $dumplog
560     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
561     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
562     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
563       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
564     fi
565   fi
566 }
567
568 function check_vob_for_too_many_video_packets {
569   # If our earlier algorithm to work around this failed, throw an error.
570   # check to see if this DVD has a protection scheme we don't know how to work around
571   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
572   # for some reason, the video is black, while the audio rolls, then the video finally comes
573   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
574   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
575   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
576   grep -q "Too many video packets in the buffer:" "$logfile"
577   if [ $? == 0 ]; then
578     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
579     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
580     create_main_vob_with_mplayer "$isofile"
581     grep -q "Too many video packets in the buffer:" $dumplog
582     if [ $? == 0 ]; then
583       [[ -e "$dumplog" ]] && rm -f $dumplog
584       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
585     fi
586     [[ -e "$dumplog" ]] && rm -f $dumplog
587   fi
588 }
589
590 function check_vob_for_a52_crc_errors {
591   # Let's see if we can playback our newly created VOB file without any errors.
592   # if there are issues, let's detect them now, and try to recreate the VOB
593   # there are some forms of copy protection that have missed above, that evidence
594   # themselves when we try to playback the VOB file. This was added to deal with
595   # the "a52: CRC check failed" copy protection scheme.
596   MAX_ERRORS=10
597   ENDPOS=120
598   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
599   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
600   cat $dumplog | grep -v "^A:" >> "$logfile"
601   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
602   if [ $errors -gt $MAX_ERRORS ]; then
603     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
604     create_main_vob_with_mplayer "$isofile"
605     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
606     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
607     if [ $? != 0 ]; then
608       cat $dumplog | grep -v "^A:" >> "$logfile"
609       fatal_and_exit "-E- Mplayer Failed"
610     fi
611     cat $dumplog | grep -v "^A:" >> "$logfile"
612     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
613     if [ $errors -gt $MAX_ERRORS ]; then
614       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
615     fi
616   fi
617   [[ -e "$dumplog" ]] && rm -f $dumplog
618 }
619
620 function calculate_bitrate_from_target_size {
621   # determine what our bitrate needs to be if a target size was specified instead
622   if [ $target_size -ne 0 ]; then
623     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
624     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
625     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
626   fi
627 }
628
629 function create_dvdauthor_dvd_xml_file {
630   # make a dvdauthor xml menu file to create a valid DVD video from 
631   # this script does a good job, but we'll still need to clean it up a bit after it runs
632   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
633   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
634   if [ $? != 0 ]; then
635     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
636   fi
637
638   # replace the first line of the xml file to remove the bad dest path
639   awk -v line=1 -v new_content="<dvdauthor>" '{
640     if (NR == line) {
641       print new_content;
642     } else {
643       print $0;
644     }
645   }' dvd.xml > dvd.xml.new
646   mv -f dvd.xml.new dvd.xml
647   if [ $? != 0 ]; then
648     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
649   fi
650
651   # remove the "<video " property line from the xml file
652   cat dvd.xml | grep -v "<video" > dvd.xml.new
653   mv -f dvd.xml.new dvd.xml
654   if [ $? != 0 ]; then
655     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
656   fi
657   
658   # remove the extra <pgc>..</pgc> pairs
659   cat dvd.xml | awk 'BEGIN {x=1}
660   {
661     if ($0~"</pgc>") {x=0}
662     if (x==1) {print $0}
663     if ($0~"<pgc>") {x=1}
664   }' > dvd.xml.new
665   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
666   mv -f dvd.xml.new dvd.xml
667   if [ $? != 0 ]; then
668     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
669   fi
670
671   # remove the VTS_*_0.VOB file as this is just the main menu video clip
672   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
673   mv -f dvd.xml.new dvd.xml
674   if [ $? != 0 ]; then
675     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
676   fi
677 }
678
679 function check_for_mplayer_dumpstream_incompatibility {
680
681   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
682
683   if [ ! -e "$vobfile" ]; then
684     # mplayer dumpstream does not work on DVDs that obscure the feature title.
685     # A DVD that has 99 titles, where the longest title isn't the main feature
686     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
687     # out what the feature title is. This script will run through that flow if we
688     # set use_mplayer_dumpstream to 0. Check for this here.
689     if [ $ripdvd -eq 1 ]; then
690       lsdvd $dev | grep -q "Title: 99"
691     else
692       lsdvd "$isofile" | grep -q "Title: 99"
693     fi
694     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
695     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
696       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
697         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
698         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
699         invalid_feature_title=1
700       else 
701         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
702         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
703         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
704         use_mplayer_dumpstream=0
705         invalid_feature_title=1
706       fi
707       return
708     fi
709   fi
710
711   # There is another form of protection that causes the mplayer dumpstream to fail. 
712   # This can be detected by telling mplayer to parse the VOB file by copying its audio
713   # video streams to a dummy output file (/dev/null). Do that here to check for that 
714   # problem before continuing.
715   if [ -e "$vobfile" ]; then
716     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
717     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
718     grep -q "Too many audio packets in the buffer" $dumplog
719     if [ $? == 0 ]; then
720       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
721       use_mplayer_dumpstream=0
722       mplayer_dumpstream_incompatibility=1
723     fi
724     [[ -e "$dumplog" ]] && rm -f $dumplog
725   fi
726 }
727
728 function fill_mythvideo_metadata {
729
730   # This function must be passed the filename as an argument
731   # The filename must be a full path to the file
732   filename="$1"
733
734   # Make sure the fill mythvideo metadata option has been set to 1
735   if [ $fill_mythvideo_metadata -eq 0 ]; then
736     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
737     return 0
738   fi
739
740   # If the fill mythvideo metadata script is present, run it
741   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
742   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
743     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
744     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
745   else
746     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
747     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
748   fi
749 }
750
751 function remove_intermediate_vob_file {
752   # remove the intermediate VOB file
753   if [ $keep_intermediate_files -eq 0 ]; then
754     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
755   else
756     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
757   fi
758 }
759
760 function remove_intermediate_iso_file {
761   # remove the original DVD image 
762   if [ $keep_intermediate_files -eq 0 ]; then
763     [[ -e "$isofile" ]] && rm "$isofile"
764   else
765     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
766   fi
767 }
768
769 function remove_intermediate_dvdbackup_folder {
770   if [ $keep_intermediate_files -eq 0 ]; then
771     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
772   else
773     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
774   fi
775 }
776
777 ###############################################
778 # MAIN
779
780 # Make a note of when this DVD rip started
781 date=`date`
782 echo -e "\n$date DVD rip started" >> "$logfile"
783
784 # Rip the DVD - Mirror Mode
785 if [ $mirror_mode -eq 1 ]; then
786   echo "-> Ripping DVD $dvdname to $dest"
787
788   # use ddrescue to make an ISO image of the disk
789   make_dvd_iso_image "$dest/$dvdname.iso"
790
791   # add this video data to the mythtv DB
792   fill_mythvideo_metadata "$dest/$dvdname.iso" 
793
794   # eject the disk upon completion
795   eject -T $dev
796
797   date=`date`
798   echo "$date DVD rip completed" | tee -a "$logfile"
799
800   if [[ -n "$mailto" ]]; then
801     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
802   fi
803
804 fi
805
806 # Rip the DVD - Main Title Feature Only
807 if [ $mirror_mode -eq 0 ]; then
808
809   # Rip image from DVD
810   if [ $ripdvd -eq 1 ]; then
811     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
812     # use ddrescue to make an ISO image of the disk
813     make_dvd_iso_image "$tmpdir/$dvdname.iso"
814   fi
815
816   # Rip image from DVD path
817   if [ -n "$dvdpath" ]; then
818     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
819     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
820   fi
821
822   # make sure our isofile value is set
823   if [ -z "$isofile" ]; then
824     isofile="$tmpdir/$dvdname.iso"
825   fi
826      
827   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
828
829     if [ ! -e "$vobfile" ]; then
830       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
831       
832       # get the feature title from the ISO
833       get_feature_title "$isofile"
834  
835       # get the crop value from the ISO
836       get_crop_from_iso
837
838       # check for mplayer dumpstream incompatibilities
839       # if they exist, this method will set this mode to 0.
840       check_for_mplayer_dumpstream_incompatibility
841
842       if [ $use_mplayer_dumpstream -eq 1 ]; then 
843
844         # get our audio id from the ISO file
845         get_audio_id_from_iso
846
847         # create our main VOB file from the ISO
848         create_main_vob_with_mplayer "$isofile"
849      
850         # remove the intermediate VOB file
851         remove_intermediate_vob_file
852
853         # it's possible that our VOB is still corrupted in some manner
854         # check to make sure it is still a good VOB before continuing.
855         check_for_mplayer_dumpstream_incompatibility
856
857       fi
858  
859       if [ $use_mplayer_dumpstream -eq 0 ]; then 
860
861         # use dvdbackup to make a DVD folder of the feature title
862         make_dvdbackup_folder_image
863   
864         # create our main VOB file
865         create_main_vob_with_cat
866
867         # get our audio id from the VOB file
868         get_audio_id_from_vob
869   
870         # check for corrupted VOB start
871         check_vob_for_corrupted_start
872  
873         # check to make sure our VOB is complete
874         check_vob_for_completeness
875
876         # check to make sure our VOB doesn't have too many video packets
877         check_vob_for_too_many_video_packets
878
879         # check to make sure our VOB doesn't have a52 crc errors
880         check_vob_for_a52_crc_errors
881
882         # remove the intermediate VOB file
883         remove_intermediate_vob_file
884
885       fi
886
887       # remove the intermediate ISO file
888       remove_intermediate_iso_file
889
890     else
891       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
892     fi
893
894     # transcode the DVD
895     if [ $make_final_dest_avi -eq 1 ]; then
896       echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
897
898       # determine what our bitrate needs to be if a target size was specified instead
899       calculate_bitrate_from_target_size        
900       
901       # There was a lot of experimentation to arrive at these values
902       # These seem to work OK for me. If they don't work for you, feel
903       # free to adjust/change as needed.
904
905       # Edit these as needed to suite your needs
906       mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
907       mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
908       mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
909       mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=2"
910
911       # There are a number of different ways to encode 6 channel audio.
912       # I've loaded 3 different ways into the mencoder_audioch_opts.
913       # It will cycle through them until it finds one that works. 
914       # You can change the order to suit your needs.
915       if [ $audio_2ch -eq 0 ]; then
916
917         # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
918         #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
919         #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
920
921         # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
922         # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad 
923         mencoder_audio_opts="-oac copy"
924
925         # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
926         mencoder_audioch_opts[0]="-channels 6 -af channels=6"
927         mencoder_audioch_opts[1]="-af channels=6"
928         mencoder_audioch_opts[2]=""
929
930      else 
931         # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
932         mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
933         mencoder_audioch_opts[0]=""
934      fi
935
936       # Do not edit this line. $mencoder_video_encoder_opts must be last
937       mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
938       mencoder_retval=0
939
940       for PASS in 1 2 
941       do 
942         # Set some options based on which pass we are in
943         mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
944         [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
945         [ $PASS -eq 1 ] && output_file="/dev/null"
946         [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
947   
948         # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
949         for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
950         do
951           echo -e "   Encoding pass $PASS"
952           echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
953           mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
954           mencoder_retval=$? 
955           grep -q "\[channels\] Invalid" $encodelog
956           if [ $? != 0 ]; then      
957             break;
958           else
959             echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
960           fi
961         done
962         if [ $mencoder_retval != 0 ]; then
963           fatal_and_exit "-E- Unhandled mencoder error"
964         fi
965         # Concatenate the encode log to our main log file, greping out unwanted lines
966         cat $encodelog | grep -v "Pos:" >> "$logfile"
967       done
968
969       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
970         [[ -e "$vobfile" ]] && rm -f "$vobfile";
971         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
972       else
973         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
974         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
975       fi
976     fi
977
978   # add this video data to the mythtv DB
979   [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi" 
980   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
981     
982   else
983
984   # use dvdbackup to make a DVD folder of the feature title
985   make_dvdbackup_folder_image
986
987   # cd to the feature title DVD folder
988   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
989   if [ $? != 0 ]; then
990     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
991   fi
992   
993   # create the dvd.xml file for dvdauthor
994   create_dvdauthor_dvd_xml_file  
995
996   # make the final DVD folder image
997   make_dvdauthor_folder_image
998
999   # add this video data to the mythtv DB
1000   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1001  
1002   # cd back to the dir we started from
1003   popd > /dev/null 2>&1
1004
1005   if [ $make_final_dest_iso -eq 1 ]; then
1006
1007     # make an iso image out of our directory
1008     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1009    
1010     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1011     if [ -s "$dest/$dvdname.iso" ]; then
1012       if [ $make_final_dest_folder -eq 0 ]; then
1013         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1014         # remove the folder of the DVD image now that we have a .iso version of it
1015         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1016       fi
1017     else
1018       # we created an empty iso file, remove it
1019       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1020       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1021       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1022     fi
1023  
1024     # add this video data to the mythtv DB
1025     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1026
1027   fi
1028
1029   fi
1030
1031   # remove the ddrescue DVD ISO image
1032   remove_intermediate_iso_file
1033
1034   # remove the tmp dvdbackup folder of the DVD image
1035   remove_intermediate_dvdbackup_folder
1036
1037   # eject the DVD disk upon completion
1038   [ $ripdvd -eq 1 ] && eject -T $dev
1039
1040   date=`date`
1041   echo "$date DVD rip completed" | tee -a "$logfile"
1042
1043   if [[ -n "$mailto" ]]; then
1044     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1045   fi
1046
1047 fi
1048